//-----------------------------------------------------------------------------
#include "hardkeyhandler_stub.h"
//-----------------------------------------------------------------------------

#include <QKeySequence>

#include <QDebug>

//-----------------------------------------------------------------------------
HardkeyHandlerPrivate::HardkeyHandlerPrivate(HardkeyHandler* a_handler)
{
  qDebug() << "HardkeyHandlerPrivate::HardkeyHandlerPrivate(): Stub!";

  publicHandler = a_handler;
}

//-----------------------------------------------------------------------------
HardkeyHandlerPrivate::~HardkeyHandlerPrivate()
{
}

//-----------------------------------------------------------------------------
#ifdef Q_WS_X11
bool HardkeyHandlerPrivate::processX11Event(XEvent* event)
{
  if ( event->type == KeyPress )
  {
      if (event->xkey.keycode == 73 || event->xkey.keycode == QKeySequence::ZoomOut)
      {
          emit publicHandler->decreaseKeyPressed();
          return true;
      }
      else if (event->xkey.keycode == 74  || event->xkey.keycode == QKeySequence::ZoomIn)
      {
          emit publicHandler->increaseKeyPressed();
          return true;
      }
  }

  return false;
}
#endif

//-----------------------------------------------------------------------------
void HardkeyHandlerPrivate::grabIncreaseDecreaseKeys(QWidget* window, bool grab)
{
}

//-----------------------------------------------------------------------------
